{# Group mappings into services by the same scheme+host+port #}
{%- set services = [] %}
{%- for mapping in rps_mappings %}
  {%- set scheme = mapping["source"] | urlsplit("scheme") %}
  {%- set is_tls = true if scheme == 'https' else false %}
  {%- set default_port = is_tls | ternary(443, 80) %}
  {%- set port = mapping["source"] | urlsplit("port") | default(default_port, true) %}
  {%- set host = mapping["source"] | urlsplit("hostname") %}
  {%- set service_id = "{}://{}:{}".format(scheme, host, port) | hash("md5") %}

  {%- set group_by = {"new_group": true} %}
  {%- for service in services %}
    {%- if service["id"] == service_id %}
      {%- set _ = service["mappings"].append(mapping) %}
      {%- set _ = group_by.update({"new_group": false}) %}
    {%- endif %}
  {%- endfor %}

  {%- if group_by["new_group"] %}
    {%- set _ = services.append({
      "id": service_id,
      "scheme": scheme,
      "host": host,
      "port": port,
      "is_tls": is_tls,
      "mappings": [mapping]
    }) %}
  {%- endif %}
{%- endfor %}

###############################################################################
### CACHE CONFIG
###############################################################################

{%- set cache_zone = "cache_" + (env_name | hash('md5')) %}

proxy_cache_path
  /var/cache/nginx
  levels=1:2
  keys_zone={{ cache_zone }}:10m
  max_size={{ max_cache_size }}
  inactive=10s
  use_temp_path=off;

map $http_x_ec_rps_cache $cache_purge {
  "purge" 1;
  default 0;
}

map $http_x_cache_bypass $proxy_cache_bypass {
  "1" 1;
  default 0;
}


{% if nginx_plus_enabled and saml_enabled %}
###############################################################################
### SAML CONFIGURATION
###############################################################################

{% include "nginx-saml.j2" %}
{% endif %}

###############################################################################
### UPSTREAMS DECLARATION
###############################################################################

{% include "nginx-upstreams.j2" %}

###############################################################################
### SERVER: DEFAULT 404
###############################################################################

server {
  listen 80 default_server;
  http2 on;

  server_name _;
  server_name "";

  #############################################################################
  ### NGINX+ API for Prometheus Exporter

  location = /snet/nginx/api {
    rewrite ^ /snet/nginx/api/ permanent;
  }

  {%- if nginx_plus_enabled %}
  location /snet/nginx/api/ {
    api write=off;
    access_log off;
    allow      127.0.0.1;
    deny       all;
  }
  {%- endif %}

  location = /snet/nginx/status {
    rewrite ^ /snet/nginx/status/ permanent;
  }

  location /snet/nginx/status {
    stub_status;
    access_log off;
    allow      127.0.0.1;
    deny       all;
  }

  #############################################################################
  ### RPS Agent for Netbox integration

  location ~ /snet/agent/(.*) {
    set $mapping_source_path "/snet/agent/";
    set $mapping_target_path "/";

    js_import rewrite_engine from scripts.d/rewrite_engine.js;
    js_set $proxied_uri rewrite_engine.rewrite_uri;

    proxy_pass http://127.0.0.1:8000$proxied_uri;

    {%- if restricted_allowed_origins %}
      {%- for origin in restricted_allowed_origins %}
    allow {{ origin }};
      {%- endfor %}
    deny all;
    {%- endif %}
  }

  #############################################################################
  ### Prometheus Exporter Metrics

  location = /snet/metrics {
    rewrite ^ /snet/metrics/ permanent;
  }

  location = /snet/metrics/ {
    set $mapping_source_path "/snet/metrics/";
    set $mapping_target_path "/metrics";

    js_import rewrite_engine from scripts.d/rewrite_engine.js;
    js_set $proxied_uri rewrite_engine.rewrite_uri;

    proxy_pass http://127.0.0.1:9113$proxied_uri;
  }

  #############################################################################
  ### Health Check

  location = /snet/health {
    rewrite ^ /snet/health/ permanent;
  }

  location /snet/health/ {
    error_log    /dev/null emerg;
    access_log   off;

    return 200;
    break;
  }

  {%- if nginx_plus_enabled and saml_enabled %}
  #############################################################################
  ### SAML variables definition

  set $saml_request_id "";
  set $saml_response_id "";
  {%- endif %}

  #############################################################################
  ### Default route

  location / {
    return 404;
  }
}

{% for service in services %}
{% include "nginx-service.j2" %}
{% endfor %}
